org.apache.maven.plugin

## Interface PluginManager

- All Known Implementing Classes:
    DefaultPluginManager

      public interface PluginManager

  Version:
    $Id: PluginManager.java 799758 2009-07-31 22:19:38Z jdcasey $
  Author:
    Jason van Zyl

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `ROLE`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `executeMojo(MavenProject project, MojoExecution execution, MavenSession session)`
    `java.lang.Object` | `getPluginComponent(Plugin plugin, java.lang.String role, java.lang.String roleHint)`
    `java.util.Map` | `getPluginComponents(Plugin plugin, java.lang.String role)`
    `Plugin` | `getPluginDefinitionForPrefix(java.lang.String prefix, MavenSession session, MavenProject project)`
    `PluginDescriptor` | `getPluginDescriptorForPrefix(java.lang.String prefix)`
    `MavenReport` | `getReport(MavenProject project, MojoExecution mojoExecution, MavenSession session)`
    `PluginDescriptor` | `loadPluginDescriptor(Plugin plugin, MavenProject project, MavenSession session)`
    `PluginDescriptor` | `loadPluginFully(Plugin plugin, MavenProject project, MavenSession session)`
    `PluginDescriptor` | `verifyPlugin(Plugin plugin, MavenProject project, Settings settings, ArtifactRepository localRepository)` Deprecated. Use `loadPluginDescriptor(Plugin, MavenProject, MavenSession)` instead.
    `PluginDescriptor` | `verifyReportPlugin(ReportPlugin reportPlugin, MavenProject project, MavenSession session)`

- - ### Field Detail

    - #### ROLE

          static final java.lang.String ROLE

  - ### Method Detail

    - #### executeMojo

          void executeMojo(MavenProject project,
                         MojoExecution execution,
                         MavenSession session)
                           throws MojoExecutionException,
                                  ArtifactResolutionException,
                                  MojoFailureException,
                                  ArtifactNotFoundException,
                                  InvalidDependencyVersionException,
                                  PluginManagerException,
                                  PluginConfigurationException

      Throws:
        `MojoExecutionException`
        `ArtifactResolutionException`
        `MojoFailureException`
        `ArtifactNotFoundException`
        `InvalidDependencyVersionException`
        `PluginManagerException`
        `PluginConfigurationException`

    - #### getReport

          MavenReport getReport(MavenProject project,
                              MojoExecution mojoExecution,
                              MavenSession session)
                                throws ArtifactNotFoundException,
                                       PluginConfigurationException,
                                       PluginManagerException,
                                       ArtifactResolutionException

      Throws:
        `ArtifactNotFoundException`
        `PluginConfigurationException`
        `PluginManagerException`
        `ArtifactResolutionException`

    - #### getPluginDescriptorForPrefix

          PluginDescriptor getPluginDescriptorForPrefix(java.lang.String prefix)

    - #### getPluginDefinitionForPrefix

          Plugin getPluginDefinitionForPrefix(java.lang.String prefix,
                                            MavenSession session,
                                            MavenProject project)

    - #### verifyPlugin

          PluginDescriptor verifyPlugin(Plugin plugin,
                                      MavenProject project,
                                      Settings settings,
                                      ArtifactRepository localRepository)
                                        throws ArtifactResolutionException,
                                               PluginVersionResolutionException,
                                               ArtifactNotFoundException,
                                               InvalidVersionSpecificationException,
                                               InvalidPluginException,
                                               PluginManagerException,
                                               PluginNotFoundException,
                                               PluginVersionNotFoundException

      Deprecated. Use `loadPluginDescriptor(Plugin, MavenProject, MavenSession)` instead.
      Throws:
        `ArtifactResolutionException`
        `PluginVersionResolutionException`
        `ArtifactNotFoundException`
        `InvalidVersionSpecificationException`
        `InvalidPluginException`
        `PluginManagerException`
        `PluginNotFoundException`
        `PluginVersionNotFoundException`

    - #### verifyReportPlugin

          PluginDescriptor verifyReportPlugin(ReportPlugin reportPlugin,
                                            MavenProject project,
                                            MavenSession session)
                                              throws PluginVersionResolutionException,
                                                     ArtifactResolutionException,
                                                     ArtifactNotFoundException,
                                                     InvalidVersionSpecificationException,
                                                     InvalidPluginException,
                                                     PluginManagerException,
                                                     PluginNotFoundException,
                                                     PluginVersionNotFoundException

      Throws:
        `PluginVersionResolutionException`
        `ArtifactResolutionException`
        `ArtifactNotFoundException`
        `InvalidVersionSpecificationException`
        `InvalidPluginException`
        `PluginManagerException`
        `PluginNotFoundException`
        `PluginVersionNotFoundException`

    - #### getPluginComponent

          java.lang.Object getPluginComponent(Plugin plugin,
                                            java.lang.String role,
                                            java.lang.String roleHint)
                                              throws PluginManagerException,
                                                     ComponentLookupException

      Throws:
        `PluginManagerException`
        `ComponentLookupException`

    - #### getPluginComponents

          java.util.Map getPluginComponents(Plugin plugin,
                                          java.lang.String role)
                                            throws ComponentLookupException,
                                                   PluginManagerException

      Throws:
        `ComponentLookupException`
        `PluginManagerException`

    - #### loadPluginDescriptor

          PluginDescriptor loadPluginDescriptor(Plugin plugin,
                                              MavenProject project,
                                              MavenSession session)
                                                throws ArtifactResolutionException,
                                                       PluginVersionResolutionException,
                                                       ArtifactNotFoundException,
                                                       InvalidVersionSpecificationException,
                                                       InvalidPluginException,
                                                       PluginManagerException,
                                                       PluginNotFoundException,
                                                       PluginVersionNotFoundException

      Throws:
        `ArtifactResolutionException`
        `PluginVersionResolutionException`
        `ArtifactNotFoundException`
        `InvalidVersionSpecificationException`
        `InvalidPluginException`
        `PluginManagerException`
        `PluginNotFoundException`
        `PluginVersionNotFoundException`
      Since:
        2.2.1

    - #### loadPluginFully

          PluginDescriptor loadPluginFully(Plugin plugin,
                                         MavenProject project,
                                         MavenSession session)
                                           throws ArtifactResolutionException,
                                                  PluginVersionResolutionException,
                                                  ArtifactNotFoundException,
                                                  InvalidVersionSpecificationException,
                                                  InvalidPluginException,
                                                  PluginManagerException,
                                                  PluginNotFoundException,
                                                  PluginVersionNotFoundException

      Throws:
        `ArtifactResolutionException`
        `PluginVersionResolutionException`
        `ArtifactNotFoundException`
        `InvalidVersionSpecificationException`
        `InvalidPluginException`
        `PluginManagerException`
        `PluginNotFoundException`
        `PluginVersionNotFoundException`
      Since:
        2.2.1